# Introduction

Welcome to the **Software Testing - Advanced Features** module!

During the Testing - Fundamentals module you were exposed to the basic aspects of automated testing. You've learnt about the importance of testing 
in software development and how to properly ensure that your methods are actually behaving as you're expecting them to.<br>

However, as your programming skills developed and the code you're writing became more and more complex, also the testing that
validates it must keep up and be able to ensure that every edge case is covered. Think about testing database integrations or web controllers.


Some of the more advanced frameworks and testing features that are going to be explained during this module are:
- JUnit5 and its Java 8 and above features like:
    -   repeating tests
    -   grouping multiple assertions
    -   parameterized tests
- Mockito for:
    -   verifying method executions
    -   mocking complex objects


## Presentation
Presentation is available under [this link](https://gitlab.com/sda-international/program/java/testing-advanced-features/wikis/uploads/d5f8a6b72b0c4b3fcb3e44b5a3a79ba2/17_Software_Testing_Advanced_Features.pdf).

# Further reading

## Books

1.  Test-Driven Java Development, Viktor Farcic, Alex Garcia
2.  Mastering Software Testing with JUnit 5: Comprehensive guide to develop high quality Java applications, Boni Garcia
3.  Practical Unit Testing with JUnit and Mockito, Tomek Kaczanowski

## Links

1.  https://www.baeldung.com/junit-5
2.  https://www.petrikainulainen.net/junit-5-tutorial/
3.  https://www.baeldung.com/mockito-series
4.  https://www.tutorialspoint.com/mockito/index.htm